_copyright__ = "Copyright (c) 2017 CollabNet, Inc. All rights reserved."

from app.scripts import BaseConfigScript
import os
import app.defaults


class ConfigScript(BaseConfigScript):

    def configSnippet(self):
        ssl_config = ''

        if self.cfg.get("SSL", "off").lower() == "on":

            domainName = app.landscape.Landscape.getSite().getLocalMachine().getPublicAddress().getName()

            targetCertPath = os.path.join(app.defaults.DEFAULT_SSLCERTS_PATH, domainName + ".crt")
            targetKeyPath  = os.path.join(app.defaults.DEFAULT_SSLCERTS_PATH, domainName + ".key")
        
            ssl_config = """
    ssl on;
    ssl_certificate       %s;
    ssl_certificate_key   %s;
    ssl_protocols TLSv1 TLSv1.1 TLSv1.2;
            """ % (targetCertPath, targetKeyPath)
                
        return ssl_config
