_copyright__ = "Copyright (c) 2017 CollabNet, Inc. All rights reserved."

from app.scripts import BaseConfigScript

import urllib
import os
import re

class ConfigScript(BaseConfigScript):

    def configSnippet(self):

        # rabbitmq_app_services_password = "<%= ERB::Util.url_encode(Utils.decrypt('{__OBFUSCATE:RABBITMQ_APP_SERVICES_PASSWORD__}')) %>"
        # mongodb_password = "<%= Utils.decrypt('{__OBFUSCATE:MONGODB_APP_SERVICES_PASSWORD__}') %>"
        # scm_password = "<%= Utils.decrypt('{__OBFUSCATE:SCM_ADMIN_PASSWORD__}') %>"
        # admin_password = "<%= Utils.decrypt('{__OBFUSCATE:RABBITMQ_APP_ADMIN_PASSWORD__}') %>"
        # permission_publisher_password = "<%= Utils.decrypt('{__OBFUSCATE:RABBITMQ_PERMISSION_PUBLISHER_PASSWORD__}') %>"

        rabbitmq_app_services_password='{__OBFUSCATE:RABBITMQ_APP_SERVICES_PASSWORD__}'
        mongodb_password='{__OBFUSCATE:MONGODB_APP_SERVICES_PASSWORD__}'
        scm_password='{__OBFUSCATE:SCM_ADMIN_PASSWORD__}'
        admin_password='{__OBFUSCATE:RABBITMQ_APP_ADMIN_PASSWORD__}'
        permission_publisher_password='{__OBFUSCATE:RABBITMQ_PERMISSION_PUBLISHER_PASSWORD__}'


        domainName = self.cfg["eventq/dependency/ctfcore-app/http-soap/remote-host"]

        self.database_name = self.determineDatabaseName()

        defaults_yml = """
rabbitmq:
  production:
    uri: amqp://{__RABBITMQ_APP_SERVICES_USER__}:%s@{__eventq/dependency/rabbitmq/amqp/remote-host__}:{__eventq/dependency/rabbitmq/amqp/port__}
    admin_user: {__RABBITMQ_APP_ADMIN_USER__}
    admin_password: %s
    permission_publisher: {__RABBITMQ_PERMISSION_PUBLISHER__}
    permission_publisher_password: %s

mongo:
  production:
    host: {__eventq/dependency/mongodb/mongodb/remote-host__}
    port: {__eventq/dependency/mongodb/mongodb/port__}
    database: %s
    username: {__MONGODB_APP_SERVICES_USER__}
    password: %s

teamforge:
  production:
    server: {__HTTP_SCHEME__}://%s
    iaf:
      admin_user: scmadmin
      admin_pass: %s
      orc_url: {__HTTP_SCHEME__}://%s{__EVENTQ_PROXIED_PATH__}
    enabled: true

security:
  production:
    permissions_timeout: 7200
            """ % ("<%= ERB::Util.url_encode(Utils.decrypt('" + rabbitmq_app_services_password + "')) %>",
                   "<%= Utils.decrypt('" + admin_password + "') %>", "<%= Utils.decrypt('" + permission_publisher_password + "') %>",
                   self.database_name, "<%= Utils.decrypt('" + mongodb_password + "') %>", domainName,
                   "<%= Utils.decrypt('" + scm_password + "') %>", domainName)

        return defaults_yml


    def determineDatabaseName(self):
        database_name = self.cfg['MONGODB_APP_DATABASE_NAME']
        eventqConfDir = os.path.join(self.cfg['EVENTQ_APP_DIR'], 'config')
        defaults_yml_file = os.path.join(eventqConfDir, 'defaults.yml')

        if os.path.isfile(defaults_yml_file):
            with open(defaults_yml_file) as fd:
                for line in iter(fd):
                    line = line.strip()
                    match = re.match('^database:\s*(\S*)', line)
                    if match:
                        database_name = match.group(1)

        return database_name