_copyright__ = "Copyright (c) 2017 CollabNet, Inc. All rights reserved."

from app.scripts import BaseConfigScript

import os
import re

class ConfigScript(BaseConfigScript):

    def configSnippet(self):
        self.database_name = self.determineDatabaseName()

        mongodb_password='{__OBFUSCATE:MONGODB_APP_SERVICES_PASSWORD__}'

        mongoid_yml = """
production:
  clients:
    default:
      hosts:
       - {__eventq/dependency/mongodb/mongodb/remote-host__}:{__eventq/dependency/mongodb/mongodb/port__}
      database: %s
      options:
        user: {__MONGODB_APP_SERVICES_USER__}
        password: %s
  options:
    raise_not_found_error: false

identity_map_enabled: true
            """ % (self.database_name, "<%= Utils.decrypt('" + mongodb_password + "') %>")

        return mongoid_yml


    def determineDatabaseName(self):
        database_name = self.cfg['MONGODB_APP_DATABASE_NAME']
        eventqConfDir = os.path.join(self.cfg['EVENTQ_APP_DIR'], 'config')
        defaults_yml_file = os.path.join(eventqConfDir, 'defaults.yml')

        if os.path.isfile(defaults_yml_file):
            with open(defaults_yml_file) as fd:
                for line in iter(fd):
                    line = line.strip()
                    match = re.match('^database:\s*(\S*)', line)
                    if match:
                        database_name = match.group(1)
                        break

        return database_name
