_copyright__ = "Copyright (c) 2017 CollabNet, Inc. All rights reserved."

from app.scripts import BaseConfigScript

import os
import re

class ConfigScript(BaseConfigScript):

    def configSnippet(self):
        teamforge_yml = ''

        self.linked_app_id = self.getOldLinkedAppId()

        if self.linked_app_id != None:
            teamforge_yml = """
teamforge:
  production:
    linked_app_id: %s
                """ % (self.linked_app_id)

        return teamforge_yml

    def getOldLinkedAppId(self):
        linked_app_id = None
        eventqConfDir = os.path.join(self.cfg['EVENTQ_APP_DIR'], 'config')
        defaults_yml_file = os.path.join(eventqConfDir, 'defaults.yml')

        if os.path.isfile(defaults_yml_file):
            with open(defaults_yml_file) as fd:
                for line in iter(fd):
                    line = line.strip()
                    match = re.match('^linked_app_id:\s*(\S*)', line)
                    if match:
                        linked_app_id = match.group(1)

        return linked_app_id