__copyright__ = "Copyright (c) 2016 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.batch
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Generate Nginx configuration"

    def createFolderIfNotExisting(self, folder):
        if not os.path.exists(folder):
            try:
                os.makedirs(folder)
            except:
                self.logMesg("warn", "Creating folder %s %failed" % folder)

    def createRuntime(self):
        nginxConfDir = "/opt/collabnet/nginx/conf"

        self.createFolderIfNotExisting(nginxConfDir)        

        app.batch.ConfigBatch(self.log) \
            .addFolder(os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'eventq', 'conf-snippets', 'collabnet-nginx.conf.d')) \
            .evaluateIntoFile(os.path.join(nginxConfDir, "collabnet-nginx.conf"))