__copyright__ = "Copyright (c) 2017 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript

import app.batch
import os
import time
import shutil
import app.util

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Generate EventQ / TeamForge configuration"

    def createRuntime(self):

        eventqConfDir = os.path.join(self.cfg['EVENTQ_APP_DIR'], 'config')

        tmp_file = os.path.join(eventqConfDir, "teamforge.yml.tmp")
        dst_file = os.path.join(eventqConfDir, "teamforge.yml")

        app.batch.ConfigBatch(self.log) \
            .addFolder(os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'eventq', 'conf-snippets', 'teamforge.yml.d')) \
            .evaluateIntoFile(tmp_file)

        contents = open(tmp_file).read().strip()

        if contents != '':
            if os.path.isfile(dst_file):
                self.backup(dst_file)

            os.rename(tmp_file, dst_file)
        else:
            os.unlink(tmp_file)

        if os.path.isfile(dst_file):
            app.util.runSystem("chown -R %s:%s %s" % (self.cfg['EVENTQ_APP_NAME'], self.cfg['EVENTQ_APP_NAME'], dst_file), self.log)
            
    def backup(self, file):

        if os.path.isfile(file):
            timestamp = time.strftime("%Y%m%d%H%M%S")
            shutil.copy2(file, "%s.%s" % (file, timestamp))