__copyright__ = "Copyright (c) 2017 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript

import app.batch
import os
import time
import shutil
import app.util

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Create EventQ configuration"

    def createRuntime(self):

        defaults_yml_file = os.path.join(self.cfg['EVENTQ_APP_DIR'], 'config', 'defaults.yml')

        # backup defaults.yml with timestamp
        self.backup(defaults_yml_file)
    
        app.batch.ConfigBatch(self.log) \
            .addFolder(os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'eventq', 'conf-snippets', 'defaults.yml.d')) \
            .evaluateIntoFile(defaults_yml_file + '.tmp')

        os.rename(defaults_yml_file + '.tmp', defaults_yml_file)
        app.util.runSystem("chown -R %s:%s %s" % ('root', self.cfg['EVENTQ_APP_NAME'], defaults_yml_file), self.log)

    def backup(self, file):

        if os.path.isfile(file):
            timestamp = time.strftime("%Y%m%d%H%M%S")
            shutil.copy2(file, "%s.%s" % (file, timestamp))